package service

import (
	"context"
	"github.com/spf13/cast"
	"gomicro-base/api/demo"
	"gomicro-base/service/demo/internal/dao"
	"gomicro-base/service/demo/internal/model"
)

// DemoService 服务层处理逻辑
type DemoService struct {
	dao *dao.Dao
}

func New(d *dao.Dao) *DemoService {
	return &DemoService{
		dao: d,
	}
}

func (s *DemoService) GetDemo(ctx context.Context, req *demo.DemoReq) (*model.User, error) {
	user, err := s.dao.GetUserById(cast.ToInt(req.Id), []string{"*"})
	if err != nil {
		return nil, err
	}
	return user, err
}

func (s *DemoService) ListDemo(ctx context.Context, req *demo.ListDemoReq) ([]*model.User, error) {
	list, err := s.dao.ListUserGtId(cast.ToInt(req.Id), int(req.Limit))
	if err != nil {
		return nil, err
	}
	return list, nil
}
